*! version 1.0.0 December 22, 2005 @ 10:18:29
*! High-speed SQset data for program inclusion

program _sqset
version 9
	syntax [varlist(max=3 default=none)] 
	
	if "`varlist'"=="" {
		Query
		exit
	}
	
	syntax varlist(min=3 max=3)
	
	// Sequence 
	char _dta[SQis] `1' 
	char _dta[SQiis] `2' 
	char _dta[SQtis] `3'
	Check
end

program define Query
	local sqvar `_dta[SQis]'
	local ivar `_dta[SQiis]'
	local tvar `_dta[SQtis]'

	if `"`sqvar'"'=="" {
		noi di as error "sequence variable not set, use -sqset sqvar panelvar timevar"
		exit 111
	}
	
	if `"`ivar'"'=="" {
		noi di as error "panel variable not set, use -sqset sqvar panelvar timevar-"
		exit 111
	}
	
	if `"`tvar'"'=="" {
		noi di as error "time variable not set, use -sqset sqvar panelvar timevar-"
		exit 111
	}
end
	
program define Check, rclass
	local sqvar `_dta[SQis]'
	local tvar `_dta[SQtis]'
	local ivar `_dta[SQiis]'

	quietly {

		// Check Time Variable
		capture assert `tvar' < . 
		if _rc {
			noi di as error "time variable has missings"
			exit 9
		}

		tempvar control
		by `ivar' (`tvar'), sort: gen `control' = `timevar' - `timevar'[_n-1]
		sum `control', meanonly
		capture assert r(min) != r(max)
		if _rc {
			noi di as error "time variable has gaps"
			exit 9
		}

		capture assert `tvar'==int(`tvar')
		if _rc { 
			noi di as error "time variable has non integer values"
			exit 9
		}


		// Check Panel Variable
		capture assert `ivar' < . 
		if _rc {
			noi di as error "panel variable has missings"
			exit 9
		}
		capture by `ivar' `tvar': assert _n==1
		if _rc {
			noi di as error "panel variable not unique within time var"
			exit 9
		}

	}		
		
end

