*! version 1.0.0 December 22, 2005 @ 14:26:22
*! Describe Sequences 
program define sqdes
version 9

	syntax [if] [in] [, i(varname) t(varname) sq(varname) MISsing so ss graph * ]

	// Sq-Data
	capture _sqset `sq' `i' `t'
	if _rc {
		di as error "data not declared as SQ-data; use -sqset-"
		exit 9
	}


	// if/in
	if "`if'" != "" {
		tokenize "`if'", parse(" =+-*/^~!|&<>(),.")
		while "`1'" != "" {
			capture confirm variable `1'
			if !_rc {
				local iflist  "`iflist' `1'"
			}
			macro shift
		}
	}
	if "`iflist'" != "" CheckConstant `iflist', stop
	marksample touse 
	
	quietly {
		preserve
		keep if `touse'
		if "`so'" == "so" {
			by `_dta[SQiis]' (`_dta[SQtis]'), sort: keep if `_dta[SQis]' ~= `_dta[SQis]'[_n-1]
			by `_dta[SQiis]' (`_dta[SQtis]'): replace `_dta[SQtis]' = _n
		}
		
		if "`ss'" == "ss" {
			by `_dta[SQiis]' `_dta[SQis]', sort: keep if _n == 1
			sum `_dta[SQis]', meanonly
			replace `_dta[SQtis]' = cond(r(min)<0,`_dta[SQis]'+abs(r(min)),`_dta[SQis]')
		}

		tempvar count n fo ft 

		levelsof `_dta[SQis]', `missing'
		local K: word count `r(levels)'
		levelsof `_dta[SQtis]'
		local T: word count `r(levels)'
		
		keep `varlist' `iflist' `_dta[SQiis]' `_dta[SQtis]' `_dta[SQis]' 
		reshape wide `_dta[SQis]', i(`_dta[SQiis]') j(`_dta[SQtis]')
		bysort `_dta[SQis]'*: gen `count' = _N
		bysort `_dta[SQis]'*: keep if _n==1
		local Kobs = _N

		bysort `count': gen `n' = _N
		bysort `count': keep if _n==1
		gen `fo' = `n'/`Kobs'*100
		gen `ft' = 100*`n'/(`K'^`T')

	}

	di "{txt}{ralign 20:categories:}{res} `K'"
	di "{txt}{ralign 20:time points:}{res} `T'"
	di "{txt}{ralign 20:possible sequences:}{res} " `K'^`T'
	di "{txt}{ralign 20:observed sequences:}{res} " `Kobs' ///
	  "{txt} ({res}" 100*`Kobs'/(`K'^`T') ///
	  "{txt} % of possible sequences)"

	label var `count' "Observations"
	label var `n' "Sequences"
	label var `fo' "Observed %"
	label var `ft' "Theoretical %"
	
	tabdisp `count', cell(`n' `fo' `ft')
	
	if "`graph'" != "" {
		graph twoway bar `n' `count', title(Sequence-Concentration Plot) `options'
	}
	
end

program CheckConstant, rclass
	syntax varlist(default=none) [, stop]
	sort `_dta[SQiis]'
	foreach var of local varlist {
		capture by `_dta[SQiis]': assert `var' == `var'[_n-1] if _n != 1
		if _rc & "`stop'" == "" {
			di as res "`var'" as text " is not constant over time; not used"
			local varlist: subinstr local varlist "`var'" "", word
		}
		if _rc & "`stop'" != "" {
			di as error "`var' is not constant over time"
			exit 9
		}
		if "`stop'" == "" {
			return local checked "`varlist'"
		}
	}
end
	
