*! version 1.0.0 March 16, 2006 @ 16:53:40
*! List information on (person specific) sequences
program sqstattab1
version 9
	syntax [varlist(default=none)] [if] [in] [, sq(varname) i(varname) t(varname) replace * ]

	// Sq-Data
	capture _sqset `sq' `i' `t'
	if _rc {
		di as error "data not declared as SQ-data; use -sqset-"
		exit 9
	}



	// if/in
	if "`if'" != "" {
		tokenize "`if'", parse(" =+-*/^~!|&<>(),.")
		while "`1'" != "" {
			capture confirm variable `1'
			if !_rc {
				local iflist  "`iflist' `1'"
			}
			macro shift
		}
	}
	if "`iflist'" != "" CheckConstant `iflist', stop
	marksample touse 

	// Don't replace
	if "`replace'" == "" {
		preserve
	}

	// Check if hand made varlist are constants above time
	if "`varlist'" != "" CheckConstant `varlist'
	local varlist `r(checked)'
	
	// Use egen-erated sequence-information
	if "`varlist'" == "" {
		local SQgapcount: char _dta[SQgapcount]
		local SQgaplength: char _dta[SQgaplength]
		local SQitemcount: char _dta[SQitemcount]
		local SQepicount: char _dta[SQepicount]
		local SQlength: char _dta[SQlength]
		quietly levelsof `_dta[SQis]', local(K) 
		foreach k of local K {
			local charsuffix = cond(`k'<0,"`=subinstr("`k'","-","M",.)'","`k'")
			local SQlengthvars "`SQlengthvars' `: char _dta[SQlength`charsuffix']'"
			local SQepicountvars "`SQepicountvars' `: char _dta[SQepicount`charsuffix']'"
		}
		local varlist "`SQlength' `SQlengthvars' `SQgapcount' `SQgaplength' `SQitemcount' `SQepicount' `SQepicountvars'"
		format `varlist' %4.0f
	}
	
	// Output
	
	keep `_dta[SQiis]' `_dta[SQis]' `varlist' `touse'
	quietly by `_dta[SQiis]': keep if _n==1
	tab1 `varlist' if `touse', `options'
end
		
	
program CheckConstant, rclass
	syntax varlist(default=none) [, stop]
	sort `_dta[SQiis]'
	foreach var of local varlist {
		capture by `_dta[SQiis]': assert `var' == `var'[_n-1] if _n != 1
		if _rc & "`stop'" == "" {
			di as res "`var'" as text " is not constant over time; not used"
			local varlist: subinstr local varlist "`var'" "", word
		}
		if _rc & "`stop'" != "" {
			di as error "`var' is not constant over time"
			exit 9
		}
		if "`stop'" == "" {
			return local checked "`varlist'"
		}
	}
end
